# @leafygreen-ui/text-input

## 15.0.0

### Major Changes

- 0757cfbfc: Adds code splitting for test utilities

  - Adds `/testing` entry point
  - Removes `getTestUtils` from main bundle entry point

  When using the component, testing utilities won't be included into your final bundle

  ```tsx
  // App.tsx
  import { Component } from `@leafygreen-ui/<package>`
  ```

  Testing utilities (and their dependencies) will only be imported if you import them explicitly

  ```tsx
  import { getTestUtils } from `@leafygreen-ui/<package>/testing`
  ```

- 0757cfbfc: Updates Typescript build to TS5.8

### Patch Changes

- 0757cfbfc: Adds `@lg-tools/build` as a dev dependency
- 0757cfbfc: Adds missing `@lg-tools/` devDependencies.
  Updates `build`, `tsc` & `docs` scripts to use `lg-build *` cli
- 0757cfbfc: Updates `types` entry point to `./dist/types`.
  Removes redundant `compilerOptions` from TSConfig
- 0757cfbfc: Updates `main` entry point in package.json to `./dist/umd`
- Updated dependencies [0757cfbfc]
- Updated dependencies [0757cfbfc]
- Updated dependencies [0757cfbfc]
- Updated dependencies [0757cfbfc]
- Updated dependencies [0757cfbfc]
  - @leafygreen-ui/leafygreen-provider@5.0.0
  - @lg-tools/test-harnesses@0.3.0
  - @leafygreen-ui/form-field@3.0.0
  - @leafygreen-ui/typography@21.0.0
  - @leafygreen-ui/emotion@5.0.0
  - @leafygreen-ui/tokens@3.0.0
  - @leafygreen-ui/hooks@9.0.0
  - @leafygreen-ui/lib@15.0.0

## 14.0.13

### Patch Changes

- @leafygreen-ui/form-field@2.0.12
- @leafygreen-ui/typography@20.1.9

## 14.0.12

### Patch Changes

- bce45dba1: `defaultValue` property now works as expected.
  - @leafygreen-ui/emotion@4.1.1

## 14.0.11

### Patch Changes

- Updated dependencies [21bcd4195]
  - @leafygreen-ui/hooks@8.4.1
  - @leafygreen-ui/form-field@2.0.11
  - @leafygreen-ui/leafygreen-provider@4.0.7
  - @leafygreen-ui/emotion@4.1.1
  - @leafygreen-ui/typography@20.1.8

## 14.0.10

### Patch Changes

- Updated dependencies [f2ed4b037]
  - @leafygreen-ui/emotion@4.1.1
  - @leafygreen-ui/form-field@2.0.10
  - @leafygreen-ui/hooks@8.4.0
  - @leafygreen-ui/tokens@2.12.2
  - @leafygreen-ui/typography@20.1.7

## 14.0.9

### Patch Changes

- Updated dependencies [30b13adec]
- Updated dependencies [30b13adec]
- Updated dependencies [78a36d6bb]
  - @leafygreen-ui/hooks@8.4.0
  - @leafygreen-ui/lib@14.2.0
  - @leafygreen-ui/emotion@4.1.0
  - @leafygreen-ui/form-field@2.0.9
  - @leafygreen-ui/leafygreen-provider@4.0.6
  - @leafygreen-ui/tokens@2.12.1
  - @leafygreen-ui/typography@20.1.6

## 14.0.8

### Patch Changes

- Updated dependencies [16dda633f]
  - @leafygreen-ui/leafygreen-provider@4.0.5
  - @leafygreen-ui/form-field@2.0.8
  - @leafygreen-ui/typography@20.1.5

## 14.0.7

### Patch Changes

- Updated dependencies [4b362e136]
  - @leafygreen-ui/tokens@2.12.0
  - @leafygreen-ui/form-field@2.0.7
  - @leafygreen-ui/typography@20.1.4

## 14.0.6

### Patch Changes

- Updated dependencies [0e4c5099b]
  - @leafygreen-ui/lib@14.1.0
  - @leafygreen-ui/form-field@2.0.6
  - @leafygreen-ui/hooks@8.3.6
  - @leafygreen-ui/leafygreen-provider@4.0.4
  - @leafygreen-ui/tokens@2.11.5
  - @leafygreen-ui/typography@20.1.3

## 14.0.5

### Patch Changes

- 541e12e75: Updates builds to leverage Rollup tree shaking. (see [`tools/build/config/rollup.config.mjs`](https://github.com/mongodb/leafygreen-ui/blob/main/tools/build/config/rollup.config.mjs))
- Updated dependencies [541e12e75]
- Updated dependencies [3111a76f3]
  - @leafygreen-ui/emotion@4.0.10
  - @leafygreen-ui/form-field@2.0.5
  - @leafygreen-ui/hooks@8.3.5
  - @leafygreen-ui/leafygreen-provider@4.0.3
  - @leafygreen-ui/lib@14.0.3
  - @leafygreen-ui/tokens@2.11.4
  - @leafygreen-ui/typography@20.1.2
  - @lg-tools/test-harnesses@0.2.0

## 14.0.4

### Patch Changes

- Updated dependencies [4d932fe13]
  - @leafygreen-ui/typography@20.1.1
  - @leafygreen-ui/form-field@2.0.4

## 14.0.3

### Patch Changes

- Updated dependencies [eb108e93b]
- Updated dependencies [eb108e93b]
  - @leafygreen-ui/form-field@2.0.3
  - @leafygreen-ui/typography@20.1.0

## 14.0.2

### Patch Changes

- e1955dd36: Fixes broken patch build
- Updated dependencies [e1955dd36]
  - @leafygreen-ui/emotion@4.0.9
  - @leafygreen-ui/form-field@2.0.2
  - @leafygreen-ui/hooks@8.3.4
  - @leafygreen-ui/leafygreen-provider@4.0.2
  - @leafygreen-ui/lib@14.0.2
  - @leafygreen-ui/tokens@2.11.3
  - @leafygreen-ui/typography@20.0.2
  - @lg-tools/test-harnesses@0.1.4

## 14.0.1

### Patch Changes

- 53c67fba6: [LG-4650](https://jira.mongodb.org/browse/LG-4650): migrates from `yarn` to `pnpm`
- Updated dependencies [53c67fba6]
  - @leafygreen-ui/leafygreen-provider@4.0.1
  - @lg-tools/test-harnesses@0.1.3
  - @leafygreen-ui/form-field@2.0.1
  - @leafygreen-ui/typography@20.0.1
  - @leafygreen-ui/tokens@2.11.2
  - @leafygreen-ui/hooks@8.3.3
  - @leafygreen-ui/lib@14.0.1

## 14.0.0

### Major Changes

- 274d7e1a7: Removes prop-types from LeafyGreen UI

### Patch Changes

- Updated dependencies [274d7e1a7]
  - @leafygreen-ui/leafygreen-provider@4.0.0
  - @leafygreen-ui/typography@20.0.0
  - @leafygreen-ui/lib@14.0.0
  - @leafygreen-ui/form-field@2.0.0
  - @leafygreen-ui/hooks@8.3.2
  - @leafygreen-ui/tokens@2.11.1

## 13.1.2

### Patch Changes

- 65c6f321d: [LG-4507](https://jira.mongodb.org/browse/LG-4507): bumps to [v1.2.5](https://github.com/mongodb/leafygreen-ui/blob/main/packages/form-field/CHANGELOG.md#125) of `@leafygreen-ui/form-field`

## 13.1.1

### Patch Changes

- c95b81376: [LG-4409](https://jira.mongodb.org/browse/LG-4409): bumps to [v1.2.4](https://github.com/mongodb/leafygreen-ui/blob/main/packages/form-field/CHANGELOG.md#124) of `@leafygreen-ui/form-field`
- Updated dependencies [c95b81376]
  - @leafygreen-ui/form-field@1.2.4

## 13.1.0

### Minor Changes

- 3b86b3bd: Allow type of `ReactNode` for `errorMessage` and `successMessage` props in `NumberInput`, `TextArea`, and `TextInput`

### Patch Changes

- 3273045c: Passes `readOnly` prop to `<FormField>` so that it correctly sets the `readOnly` prop.
- Updated dependencies [3273045c]
  - @leafygreen-ui/form-field@1.2.3

## 13.0.2

### Patch Changes

- Updated dependencies [dfd6972c]
  - @leafygreen-ui/typography@19.0.0
  - @leafygreen-ui/form-field@1.1.1

## 13.0.1

### Patch Changes

- 8adadc89: Fixes a bug that prevented packages from rendering in a server-side environment
- Updated dependencies [8adadc89]
  - @lg-tools/test-harnesses@0.1.2

## 13.0.0

### Major Changes

- 27ad3121: [LG-4145](https://jira.mongodb.org/browse/LG-4145)

  `aria-label` and `aria-labelledby` props are passed to the input.

  #### aria-labelledby

  `aria-labelledby` prop can only set the `aria-labelledby` attribute on the input if `label` prop is undefined. Otherwise, the generated label component id will be used for the `aria-labelledby` attribute

  | 👎 Does not use `aria-labelledby` prop                          | 👍 Does use custom `aria-labelledby` prop         |
  | --------------------------------------------------------------- | ------------------------------------------------- |
  | `<TextInput label="Label" aria-labelledby="custom-label-id" />` | `<TextInput aria-labelledby="custom-label-id" />` |

  #### aria-label

  `aria-label` prop can only set the `aria-label` attribute on the input if both `label` prop and `aria-labelledby` prop are undefined
  | 👎 Does not use `aria-label` prop | 👎 Does not use `aria-label` prop | 👍 Does use `aria-label` prop |
  | - | - | - |
  | `<TextInput label="Label" aria-label="Custom label" />` | `<TextInput aria-label="Custom label" aria-labelledby="other-custom-label-id" />` | `<TextInput aria-label="Custom label" />` |

  [LG-4143](https://jira.mongodb.org/browse/LG-4143)

  1. `FormField` styling changes apply to `TextInput`. [See style changes here](https://github.com/mongodb/leafygreen-ui/blob/main/packages/form-field/CHANGELOG.md#102)

  2. A default `errorMessage` of `'This input needs your attention'` will render below text input when state is invalid.

  3. A default `successMessage` of `'Success'` will render when state is valid. `successMessage` prop accepts a custom string.

  4. Disabled `TextInput` component no longer renders the `disabled` attribute and instead relies on `aria-disabled`.

  The last change is made to ensure that disabled components are still focusable to users using keyboard navigation.

  For more on `aria-disabled` see the [documentation on MDN](https://developer.mozilla.org/en-US/docs/Web/Accessibility/ARIA/Attributes/aria-disabled)

  #### Migration guide

  Functionally, migration should be seamless, however there may be unit/integration/e2e tests that relied on this behavior.

  ##### Jest/RTL

  Generally, only this repo should need to test that these components have a specific attribute. We recommend updating unit tests to check that some event was or was not called.

  However, there are cases where this may still need to be tested. In cases where a test checks `expect(textInput).toBeDisabled()`, you can replace and use [test harnesses](https://github.com/mongodb/leafygreen-ui/blob/main/packages/text-input/README.md#test-harnesses).

  ##### Cypress

  Similar to unit tests, you should generally test functionality and not implementation details. However, to test this in Cypress replace any `cy.get(textInput).should('be.disabled');` checks with `cy.get(textInput).invoke('attr', 'aria-disabled').should('eq', 'true');`

### Minor Changes

- c3906f78: - Extends `DarkModeProps` from `@leafygreen-ui/lib`
  - Exports `getTestUtils`, a util to reliably interact with `LG TextInput` in a product test suite. For more details, check out the [README](https://github.com/mongodb/leafygreen-ui/tree/main/packages/text-input#test-harnesses) [LG-4035](https://jira.mongodb.org/browse/LG-4035)
  - Exports the constant, `LGIDS_TEXT_INPUT`, which stores `data-lgid` values.

### Patch Changes

- Updated dependencies [c3906f78]
- Updated dependencies [9b71e34d]
- Updated dependencies [c3906f78]
- Updated dependencies [27ad3121]
- Updated dependencies [c3906f78]
- Updated dependencies [c3906f78]
  - @leafygreen-ui/form-field@1.1.0
  - @leafygreen-ui/typography@18.4.0
  - @leafygreen-ui/lib@13.4.0
  - @lg-tools/test-harnesses@0.1.1

## 12.1.27

### Patch Changes

- 356a53fd: Update TS builds to use `typescript@4.9.5`
- Updated dependencies [7a0ff1be]
- Updated dependencies [15185af0]
- Updated dependencies [356a53fd]
- Updated dependencies [66df9ab8]
  - @leafygreen-ui/typography@18.3.0
  - @leafygreen-ui/leafygreen-provider@3.1.12
  - @leafygreen-ui/form-field@1.0.1
  - @leafygreen-ui/lib@13.3.0
  - @leafygreen-ui/emotion@4.0.8
  - @leafygreen-ui/hooks@8.1.3
  - @leafygreen-ui/tokens@2.5.2

## 12.1.26

### Patch Changes

- Updated dependencies [223666eb]
- Updated dependencies [74057388]
  - @leafygreen-ui/form-field@1.0.0
  - @leafygreen-ui/icon@12.0.0
  - @leafygreen-ui/typography@18.2.3

## 12.1.25

### Patch Changes

- Updated dependencies [9b7a8236]
- Updated dependencies [7f38e78a]
- Updated dependencies [ffd11f24]
- Updated dependencies [ffd11f24]
- Updated dependencies [ffd11f24]
- Updated dependencies [ffd11f24]
- Updated dependencies [ffd11f24]
- Updated dependencies [ffd11f24]
- Updated dependencies [ffd11f24]
  - @leafygreen-ui/icon@11.27.1
  - @leafygreen-ui/leafygreen-provider@3.1.11
  - @leafygreen-ui/hooks@8.1.0
  - @leafygreen-ui/lib@13.2.0
  - @leafygreen-ui/form-field@0.3.0
  - @leafygreen-ui/typography@18.1.0

## 12.1.24

### Patch Changes

- d39acdc6: Ensure inner input element properly inherits width property from parent.

## 12.1.23

### Patch Changes

- 0b91826e: Refactors component to use FormField under the hood. Also, per the latest design guidelines, we no longer surface an error message when an input is disabled.
- Updated dependencies [dd4f3da8]
- Updated dependencies [d16fb891]
- Updated dependencies [90053e16]
  - @leafygreen-ui/lib@13.0.0
  - @leafygreen-ui/form-field@0.2.0
  - @leafygreen-ui/typography@18.0.0
  - @leafygreen-ui/leafygreen-provider@3.1.10

## 12.1.22

### Patch Changes

- Updated dependencies [3a9b274d]
  - @leafygreen-ui/lib@12.0.0
  - @leafygreen-ui/leafygreen-provider@3.1.9
  - @leafygreen-ui/typography@17.0.1

## 12.1.21

### Patch Changes

- Updated dependencies [a5770c15]
- Updated dependencies [c89d17a4]
  - @leafygreen-ui/typography@17.0.0

## 12.1.20

### Patch Changes

- Updated dependencies [3fe03b50]
- Updated dependencies [fd907503]
- Updated dependencies [c9f0055a]
- Updated dependencies [56459cde]
  - @leafygreen-ui/tokens@2.2.0
  - @leafygreen-ui/hooks@8.0.0
  - @leafygreen-ui/icon@11.23.0
  - @leafygreen-ui/leafygreen-provider@3.1.8

## 12.1.19

### Patch Changes

- Updated dependencies [4fcf2e94]
- Updated dependencies [4fcf2e94]
- Updated dependencies [4fcf2e94]
- Updated dependencies [4fcf2e94]
  - @leafygreen-ui/icon@11.22.2
  - @leafygreen-ui/lib@11.0.0
  - @leafygreen-ui/leafygreen-provider@3.1.7
  - @leafygreen-ui/typography@16.5.5

## 12.1.18

### Patch Changes

- c11bbc29: Fixes problem with ts-docs not being available in bundle.
- Updated dependencies [c11bbc29]
  - @leafygreen-ui/emotion@4.0.7
  - @leafygreen-ui/hooks@7.7.8
  - @leafygreen-ui/icon@11.22.1
  - @leafygreen-ui/leafygreen-provider@3.1.6
  - @leafygreen-ui/lib@10.4.3
  - @leafygreen-ui/palette@4.0.7
  - @leafygreen-ui/tokens@2.1.4
  - @leafygreen-ui/typography@16.5.4

## 12.1.17

### Patch Changes

- c15ee2ac: Fixes missing documentation file
- Updated dependencies [f73807cf]
- Updated dependencies [31c09354]
- Updated dependencies [c15ee2ac]
  - @leafygreen-ui/icon@11.22.0
  - @leafygreen-ui/emotion@4.0.6
  - @leafygreen-ui/hooks@7.7.7
  - @leafygreen-ui/leafygreen-provider@3.1.5
  - @leafygreen-ui/lib@10.4.2
  - @leafygreen-ui/palette@4.0.6
  - @leafygreen-ui/tokens@2.1.3
  - @leafygreen-ui/typography@16.5.3

## 12.1.16

### Patch Changes

- 215268ff: Updates build tooling. No functional changes
- Updated dependencies [215268ff]
  - @leafygreen-ui/leafygreen-provider@3.1.4
  - @leafygreen-ui/typography@16.5.2
  - @leafygreen-ui/emotion@4.0.5
  - @leafygreen-ui/palette@4.0.5
  - @leafygreen-ui/tokens@2.1.2
  - @leafygreen-ui/hooks@7.7.6
  - @leafygreen-ui/icon@11.20.1
  - @leafygreen-ui/lib@10.4.1

## 12.1.15

### Patch Changes

- 0efcd4e7: Updates valid state icon in dark mode to match Figma spec
- Updated dependencies [bf5672bb]
  - @leafygreen-ui/icon@11.18.0

## 12.1.14

### Patch Changes

- 76161cf0: Updates stories for Chromatic testing
- Updated dependencies [76161cf0]
- Updated dependencies [76161cf0]
- Updated dependencies [735342e9]
- Updated dependencies [95f5107a]
- Updated dependencies [76161cf0]
- Updated dependencies [76161cf0]
  - @leafygreen-ui/lib@10.4.0
  - @leafygreen-ui/hooks@7.7.5
  - @leafygreen-ui/icon@11.17.0
  - @leafygreen-ui/tokens@2.1.1
  - @leafygreen-ui/typography@16.5.1

## 12.1.13

### Patch Changes

- d2ce54e2f: Updates story files for Storybook 7.x
- Updated dependencies [d2ce54e2f]
- Updated dependencies [75099c60b]
- Updated dependencies [d2ce54e2f]
- Updated dependencies [0cd471676]
  - @leafygreen-ui/hooks@7.7.4
  - @leafygreen-ui/icon@11.16.1
  - @leafygreen-ui/leafygreen-provider@3.1.3
  - @leafygreen-ui/lib@10.3.4
  - @leafygreen-ui/typography@16.5.0

## 12.1.12

### Patch Changes

- a3a52e131: Bumps to use new `useIdAllocator` hook
- Updated dependencies [614f7617d]
- Updated dependencies [a3a52e131]
- Updated dependencies [614f7617d]
  - @leafygreen-ui/icon@11.15.0
  - @leafygreen-ui/hooks@7.7.3

## 12.1.11

### Patch Changes

- 32b3d3146: Bumps to use new `useIdAllocator` hook
- 73cbbd02c: Uses fontWeight token from `@leafygreen-ui/tokens`
- Updated dependencies [73cbbd02c]
- Updated dependencies [83fc5b31b]
- Updated dependencies [9bcf8b925]
- Updated dependencies [8ece56980]
- Updated dependencies [32b3d3146]
- Updated dependencies [73cbbd02c]
  - @leafygreen-ui/tokens@2.1.0
  - @leafygreen-ui/icon@11.14.0
  - @leafygreen-ui/typography@16.4.0
  - @leafygreen-ui/hooks@7.7.2

## 12.1.10

### Patch Changes

- 55d33e435: Update to BaseFontSize prop control for .design live example
- 77320a6b8: Fix padding discrepancy between Combobox, Select, Text Input, and Number Input
- f1dde4c68: Fix bug where text would overlap optional text and state indicator icons
- Updated dependencies [55d33e435]
- Updated dependencies [07db42330]
- Updated dependencies [55d33e435]
- Updated dependencies [cf00160ec]
- Updated dependencies [111b680c5]
- Updated dependencies [77320a6b8]
  - @leafygreen-ui/lib@10.3.3
  - @leafygreen-ui/palette@4.0.4
  - @leafygreen-ui/typography@16.3.0
  - @leafygreen-ui/tokens@2.0.3

## 12.1.9

### Patch Changes

- 8c0c2bdf9: Updates build script to include a transpiled copy of the story file in the bundle
- Updated dependencies [8c0c2bdf9]
  - @leafygreen-ui/emotion@4.0.4
  - @leafygreen-ui/hooks@7.7.1
  - @leafygreen-ui/icon@11.13.1
  - @leafygreen-ui/leafygreen-provider@3.1.2
  - @leafygreen-ui/lib@10.3.2
  - @leafygreen-ui/palette@4.0.3
  - @leafygreen-ui/tokens@2.0.2
  - @leafygreen-ui/typography@16.2.1

## 12.1.8

### Patch Changes

- fb47557dd: Adds warning to use `NumberInput` if `type='number'`.
- Updated dependencies [ece595acd]
- Updated dependencies [9858ab8c5]
- Updated dependencies [d351c02bc]
- Updated dependencies [c2c5601f4]
  - @leafygreen-ui/typography@16.2.0
  - @leafygreen-ui/hooks@7.7.0
  - @leafygreen-ui/icon@11.12.7
  - @leafygreen-ui/lib@10.3.1
  - @leafygreen-ui/palette@4.0.1

## 12.1.7

### Patch Changes

- 52dcb3316: Reorganizes files internally to conform to new directory structure
- Updated dependencies [5b036515e]
- Updated dependencies [26e341a0b]
- Updated dependencies [997121cc3]
- Updated dependencies [eb0cc4498]
  - @leafygreen-ui/palette@4.0.0
  - @leafygreen-ui/lib@10.2.2
  - @leafygreen-ui/icon@11.12.5
  - @leafygreen-ui/typography@16.1.0
  - @leafygreen-ui/tokens@2.0.1

## 12.1.6

### Patch Changes

- 4ccc353e7: Adds `darkMode` to PropTypes and adds warning to use `PasswordInput` if `type='password'`.
- Updated dependencies [2e8a572db]
- Updated dependencies [4ccc353e7]
- Updated dependencies [4ccc353e7]
  - @leafygreen-ui/lib@10.2.1

## 12.1.5

### Patch Changes

- bf2fedf6d: Version bumps lib
- Updated dependencies [ffb99f417]
- Updated dependencies [bf2fedf6d]
- Updated dependencies [b7a29ea38]
  - @leafygreen-ui/hooks@7.5.0
  - @leafygreen-ui/leafygreen-provider@3.1.1
  - @leafygreen-ui/typography@16.0.1

## 12.1.4

### Patch Changes

- Updated dependencies [050f1f8a9]
- Updated dependencies [741cdd408]
- Updated dependencies [866144167]
- Updated dependencies [c82ed35d5]
- Updated dependencies [b24b21462]
  - @leafygreen-ui/icon@11.12.4
  - @leafygreen-ui/tokens@2.0.0
  - @leafygreen-ui/typography@16.0.0
  - @leafygreen-ui/palette@3.4.7

## 12.1.3

### Patch Changes

- 53d77f55d: Uses Error component from Typography package to handle formatting `errorMessage` prop
- Updated dependencies [405636249]
- Updated dependencies [53d77f55d]
  - @leafygreen-ui/hooks@7.4.0
  - @leafygreen-ui/typography@15.3.0

## 12.1.2

### Patch Changes

- 9c869ced2: Fixes transition property, so that animations on hover and focus work properly
- Updated dependencies [d8c589d35]
- Updated dependencies [703db871f]
  - @leafygreen-ui/typography@15.2.1
  - @leafygreen-ui/palette@3.4.6

## 12.1.1

### Patch Changes

- 1271944b2: Updates darkMode placeholder and optional text colors to match figma specs.
- Updated dependencies [95bd93ef9]
- Updated dependencies [3bb4b7506]
- Updated dependencies [a0d6638c4]
  - @leafygreen-ui/icon@11.12.3
  - @leafygreen-ui/typography@15.2.0

## 12.1.0

### Minor Changes

- fa158335c: - Updates TS types: now Any one of `label`, `aria-label` and `aria-labelledby` is sufficient for all text input types

  - Fixes a regression when `type="search"`. Providing `aria-label` is sufficient for accessibility

### Patch Changes

- a1d093f30: Resolves aria type issues
- ae5421cf6: Updates components to use internal transition tokens
- Updated dependencies [ae5421cf6]
- Updated dependencies [4b4c2d27d]
- Updated dependencies [6a266b813]
- Updated dependencies [1a335d0b2]
- Updated dependencies [ba97d1ef7]
- Updated dependencies [ae5421cf6]
  - @leafygreen-ui/tokens@1.4.0
  - @leafygreen-ui/icon@11.12.1
  - @leafygreen-ui/typography@15.1.0

## 12.0.0

### Patch Changes

- 3cb2e1f7: Removes hover box-shadow from disabled inputs. Adds console warning suggestion to use SearchInput component in place of TextInput with type="search".
- Updated dependencies [07b3c797]
- Updated dependencies [07b3c797]
- Updated dependencies [b9b09a86]
  - @leafygreen-ui/typography@15.0.0
  - @leafygreen-ui/leafygreen-provider@3.1.0

## 11.0.1

### Patch Changes

- Updated dependencies [209f77ed]
- Updated dependencies [f2d63a60]
  - @leafygreen-ui/icon@11.12.0
  - @leafygreen-ui/lib@10.0.0
  - @leafygreen-ui/leafygreen-provider@3.0.1
  - @leafygreen-ui/typography@14.0.1

## 11.0.0

### Patch Changes

- Updated dependencies [e399f1b9]
- Updated dependencies [e399f1b9]
  - @leafygreen-ui/leafygreen-provider@3.0.0
  - @leafygreen-ui/typography@14.0.0

## 10.2.1

### Patch Changes

- 24683433: - Remove an implicit dependency on `@emotion/react` fixing an issue where LG packages would not build if `@leafygreen/emotion@4.0.2` or greater was installed.
- Updated dependencies [24683433]
  - @leafygreen-ui/emotion@4.0.3
  - @leafygreen-ui/hooks@7.3.3
  - @leafygreen-ui/icon@11.11.1
  - @leafygreen-ui/leafygreen-provider@2.3.5
  - @leafygreen-ui/lib@9.5.1
  - @leafygreen-ui/palette@3.4.4
  - @leafygreen-ui/tokens@1.3.4
  - @leafygreen-ui/typography@13.2.1

## 10.2.0

### Minor Changes

- 3690df49: Updates TypeScript annotations, type structures and export format of some components

### Patch Changes

- Updated dependencies [3690df49]
- Updated dependencies [3690df49]
- Updated dependencies [3690df49]
- Updated dependencies [3690df49]
- Updated dependencies [3690df49]
- Updated dependencies [58a5a05e]
  - @leafygreen-ui/icon@11.11.0
  - @leafygreen-ui/typography@13.2.0
  - @leafygreen-ui/lib@9.5.0
  - @leafygreen-ui/emotion@4.0.2
  - @leafygreen-ui/hooks@7.3.2
  - @leafygreen-ui/leafygreen-provider@2.3.4
  - @leafygreen-ui/palette@3.4.3
  - @leafygreen-ui/tokens@1.3.3

## 10.1.3

### Patch Changes

- 8d7534e9: Adds `tsdoc.json` to published package files
- Updated dependencies [7caa1c3e]
- Updated dependencies [e39d8469]
- Updated dependencies [8d7534e9]
  - @leafygreen-ui/icon@11.10.2
  - @leafygreen-ui/typography@13.1.2
  - @leafygreen-ui/hooks@7.3.1
  - @leafygreen-ui/leafygreen-provider@2.3.3
  - @leafygreen-ui/lib@9.4.2
  - @leafygreen-ui/palette@3.4.2
  - @leafygreen-ui/tokens@1.3.2

## 10.1.2

### Patch Changes

- b10463fc: Removing padding-top when neither label nor description are defined.

## 10.1.1

### Patch Changes

- 79b3ba7e: Aligns Text Input focus & hover styles to Figma library
- Updated dependencies [30e038a3]
  - @leafygreen-ui/palette@3.4.1

## 10.1.0

### Minor Changes

- 65c86281: Consuming darkMode from the LeafyGreenProvider if the darkMode prop is not set

### Patch Changes

- Updated dependencies [65c86281]
  - @leafygreen-ui/typography@13.1.0

## 10.0.0

### Patch Changes

- e317392f: Minor darkmode style updates, remove interaction ring from dependencies, and bump up `Typography` version.
- Updated dependencies [85d46871]
- Updated dependencies [99e20bb9]
  - @leafygreen-ui/lib@9.4.0
  - @leafygreen-ui/leafygreen-provider@2.3.0
  - @leafygreen-ui/typography@13.0.0

## 9.0.0

### Major Changes

- Updated dependencies [500d6c60]
  - @leafygreen-ui/leafygreen-provider@2.2.0

### Patch Changes

- Updated dependencies [e13d2487]
- Updated dependencies [5f28fce1]
- Updated dependencies [c48e943e]
- Updated dependencies [500d6c60]
  - @leafygreen-ui/interaction-ring@3.0.0
  - @leafygreen-ui/tokens@1.3.0
  - @leafygreen-ui/icon@11.9.0
  - @leafygreen-ui/typography@11.0.0

## 8.0.0

### Major Changes

- f3aad7e2: Updates Dark Mode for visual brand refresh

### Patch Changes

- Updated dependencies [233ac580]
- Updated dependencies [ba4aab15]
- Updated dependencies [ba4aab15]
- Updated dependencies [2cf1bc4a]
- Updated dependencies [679b6239]
- Updated dependencies [f3aad7e2]
  - @leafygreen-ui/tokens@1.2.0
  - @leafygreen-ui/typography@10.0.0
  - @leafygreen-ui/lib@9.2.1

## 7.0.1

### Patch Changes

- acd6919: Adds @leafygreen-ui/tokens dependency to package.json
- Updated dependencies [acd6919]
- Updated dependencies [acd6919]
- Updated dependencies [acd6919]
- Updated dependencies [acd6919]
  - @leafygreen-ui/lib@9.2.0
  - @leafygreen-ui/icon@11.8.0
  - @leafygreen-ui/palette@3.3.2

## 7.0.0

### Major Changes

- 8457f92: Updates text input to be in line with the visual brand refresh

### Patch Changes

- Updated dependencies [8457f92]
  - @leafygreen-ui/typography@9.0.0
  - @leafygreen-ui/interaction-ring@2.0.0
- Updated dependencies [cb54eef]
  - @leafygreen-ui/palette@3.3.1

## 6.2.1

### Patch Changes

- 548ca2c: Restores the ability to pass onBlur handlers while using the useValidation hook.

## 6.2.0

### Minor Changes

- ded2831: Add sizeVariant prop

### Patch Changes

- Updated dependencies [ded2831]
  - @leafygreen-ui/palette@3.3.0

## 6.1.0

### Minor Changes

- d661688: Adds validation callback for TextArea and TextInput

### Patch Changes

- Updated dependencies [d661688]
- Updated dependencies [d661688]
  - @leafygreen-ui/lib@9.1.0
  - @leafygreen-ui/hooks@7.1.0

## 6.0.5

### Patch Changes

- e87b1cdf: Improves the types for TextInput type attributes.
- Updated dependencies [e4070f2b]
  - @leafygreen-ui/icon@11.4.0

## 6.0.4

### Patch Changes

- fe542c15: Fixes a bug in TextInput & TextArea where the focus ring was not visible when using the mouse. Also adds functionality to InteractioRing to ignore keyboard context and use the default focus behavior.
- Updated dependencies [f6e5655a]
- Updated dependencies [03388ff2]
- Updated dependencies [fe542c15]
- Updated dependencies [b8f03aa1]
  - @leafygreen-ui/palette@3.2.2
  - @leafygreen-ui/icon@11.3.0
  - @leafygreen-ui/interaction-ring@1.1.0
  - @leafygreen-ui/lib@9.0.0
  - @leafygreen-ui/leafygreen-provider@2.1.3
  - @leafygreen-ui/typography@8.0.4

## 6.0.3

### Patch Changes

- e1af3278: Updates border-color to match TextArea component.
- Updated dependencies [047c1930]
- Updated dependencies [047c1930]
  - @leafygreen-ui/lib@8.0.0
  - @leafygreen-ui/hooks@7.0.0
  - @leafygreen-ui/icon@11.1.1
  - @leafygreen-ui/interaction-ring@1.0.4
  - @leafygreen-ui/leafygreen-provider@2.1.2
  - @leafygreen-ui/typography@8.0.2

## 6.0.2

### Patch Changes

- 37780eb8: Updates colors of the component's interaction ring on hover, based on the `state` prop on the component.

## 6.0.1

### Patch Changes

- Updated dependencies [faeb0ce0]
  - @leafygreen-ui/icon@11.0.0
  - @leafygreen-ui/typography@8.0.1

## 6.0.0

### Patch Changes

- 801f3221: Fixes check to ensure label or ariaLablledby is provided to component
- Updated dependencies [857a680a]
  - @leafygreen-ui/leafygreen-provider@2.1.0
  - @leafygreen-ui/typography@8.0.0

## 5.0.12

### Patch Changes

- 509e90c3: Checks for existence of either `label` or `aria-labelledby` props, rather than requiring both, before logging a warning to the console
- Updated dependencies [b1854dd8]
  - @leafygreen-ui/interaction-ring@1.0.3

## 5.0.11

### Patch Changes

- 90321b36: Imports validateProps functions from `@leafygreen-ui/a11y` package.
- Updated dependencies [02417199]
- Updated dependencies [ab581f34]
- Updated dependencies [90321b36]
  - @leafygreen-ui/typography@7.6.0
  - @leafygreen-ui/palette@3.2.1
  - @leafygreen-ui/lib@7.0.0
  - @leafygreen-ui/icon@10.2.1
  - @leafygreen-ui/interaction-ring@1.0.2
  - @leafygreen-ui/leafygreen-provider@2.0.3

## 5.0.10

### Patch Changes

- Updated dependencies [ec27f36e]
- Updated dependencies [ec27f36e]
  - @leafygreen-ui/typography@7.5.0
  - @leafygreen-ui/icon@10.0.0

## 5.0.9

### Patch Changes

- c6ae17bd: Updates console warning to be more reflective of error, and adds `role="presentation"` to icons rendered inside of component.
- Updated dependencies [1a42c662]
  - @leafygreen-ui/typography@7.4.0

## 5.0.8

### Patch Changes

- Updated dependencies [f805b772]
- Updated dependencies [f805b772]
  - @leafygreen-ui/icon@9.0.0
  - @leafygreen-ui/typography@7.3.2

## 5.0.7

### Patch Changes

- Updated dependencies [ba56b1cc]
  - @leafygreen-ui/icon@8.0.0
  - @leafygreen-ui/typography@7.3.1

## 5.0.6

### Patch Changes

- 36ec9078: Preserves right padding when icons are visible in a disabled text input
- Updated dependencies [2daf1808]
  - @leafygreen-ui/icon@7.1.0

## 5.0.5

### Patch Changes

- 522217db: CLOUDP-79746: Allowing text input error message to expand its container
- Updated dependencies [7df69248]
  - @leafygreen-ui/lib@6.2.0

## 5.0.4

### Patch Changes

- 919d9911: Fixes border on autoComplete disabled TextInput components

## 5.0.3

### Patch Changes

- 117fc702: Overwrites chrome browser defaults for autocompleted input values, and disables autocomplete when component is disabled

## 5.0.2

### Patch Changes

- 358a072e: Fixes visual regression where the border of inputs do not appear until text is entered
- Updated dependencies [fc18e572]
  - @leafygreen-ui/typography@7.3.0

## 5.0.1

### Patch Changes

- 988c4e3d: Allows error and valid states to display when component is disabled

## 5.0.0

### Major Changes

- 8b0ea602: Form-compatible components now display more visually consistent hover and focus states

### Patch Changes

- Updated dependencies [8b0ea602]
- Updated dependencies [8b0ea602]
  - @leafygreen-ui/interaction-ring@1.0.0
  - @leafygreen-ui/typography@7.2.0

## 4.2.0

### Minor Changes

- 627333c2: `State` is now a named export from the package

### Patch Changes

- ee7923d3: Changes how we extend the types of HTMLElements, and standardizes how we document this across readmes
- Updated dependencies [ee7923d3]
- Updated dependencies [7b71da8f]
  - @leafygreen-ui/lib@6.1.2
  - @leafygreen-ui/icon@7.0.2

## 4.1.1

### Patch Changes

- 374430ea: Updates string color value to reference the same color from uiColors palette
- Updated dependencies [c9a0d89f]
- Updated dependencies [9ee1d5fc]
  - @leafygreen-ui/palette@3.1.0
  - @leafygreen-ui/lib@6.1.1
  - @leafygreen-ui/leafygreen-provider@2.0.2

## 4.1.0

### Minor Changes

- 5a3fb225: Adds `darkMode` prop to component

## 4.0.1

### Patch Changes

- dac3f38b: Fixes a publishing error that prevented UMD modules from being distributed
- Updated dependencies [dac3f38b]
  - @leafygreen-ui/icon@7.0.1
  - @leafygreen-ui/leafygreen-provider@2.0.1
  - @leafygreen-ui/lib@6.0.1
  - @leafygreen-ui/palette@3.0.1

## 4.0.0

### Major Changes

- 0267bfd2: The underlying structure of distributed module definition files have changed and now have official support for ES modules. Module definition files are now generated using Rollup instead of Webpack. This should not affect functionality, but some thorough testing and caution should be exercised when upgrading.

### Patch Changes

- Updated dependencies [0267bfd2]
  - @leafygreen-ui/icon@7.0.0
  - @leafygreen-ui/leafygreen-provider@2.0.0
  - @leafygreen-ui/lib@6.0.0
  - @leafygreen-ui/palette@3.0.0

## 3.0.4

### Patch Changes

- 691eb05: Better support for UMD
- Updated dependencies [691eb05]
  - @leafygreen-ui/icon@6.3.2
  - @leafygreen-ui/leafygreen-provider@1.1.4
  - @leafygreen-ui/lib@5.1.1
  - @leafygreen-ui/palette@2.0.2

## 3.0.3

### Patch Changes

- 6aadc0b: Make id generation deterministic using IdAllocator.create class. This improves the SSR compatibility of these components.
- Updated dependencies [6aadc0b]
- Updated dependencies [5ee2098]
  - @leafygreen-ui/lib@5.1.0
  - @leafygreen-ui/icon@6.3.1

## 3.0.2

### Patch Changes

- Updated dependencies [2eba736]
- Updated dependencies [1aa26ee]
- Updated dependencies [d2136a0]
- Updated dependencies [a571361]
  - @leafygreen-ui/lib@5.0.0
  - @leafygreen-ui/icon@6.3.0
  - @leafygreen-ui/leafygreen-provider@1.1.2

## 3.0.1

### Patch Changes

- 5496ff4: Fix bug in input HTML such that aria-labelledby is correctly-cased

## 3.0.0

### Major Changes

- 89318bd: Conditionally renders label tag, such that when no `label` prop is supplied the tag is not on the DOM. If no `label` is provided `aria-labelledby` prop must be supplied.

## 2.0.0

### Major Changes

- 1d24966: Makes `@leafygreen-ui/leafygreen-provider` a peer dependency to ensure that components use hooks from the same version of the provider as what's installed.

## 1.1.2

### Patch Changes

- 1d86d56: Imports Glyphs directly, rather than importing the entire Icon package, when Glyph components are used
- Updated dependencies [1d86d56]
  - @leafygreen-ui/icon@6.1.0

## 1.1.1

### Patch Changes

- Updated dependencies [6fc022e]
  - @leafygreen-ui/icon@6.0.0

## 1.1.0

### Minor Changes

- 2c956d1: Allows consumer to set `type` attribute on input component

### Patch Changes

- Updated dependencies [2fc4ef9]
- Updated dependencies [e857861]
- Updated dependencies [cf6167e]
  - @leafygreen-ui/icon@5.2.0

## 1.0.4

### Patch Changes

- 2a03117: Upgrades @testing-library/react to v10 and revises test suites to conform with new standards
- Updated dependencies [2a03117]
- Updated dependencies [c812eb3]
  - @leafygreen-ui/leafygreen-provider@1.1.1
  - @leafygreen-ui/icon@5.1.0

## 1.0.3

### Patch Changes

- 1b298cc: Fix TextInput TypeScript interface.

## 1.0.2

### Patch Changes

- Updated dependencies [4c268a5]
- Updated dependencies [94ed125]
  - @leafygreen-ui/icon@5.0.0
  - @leafygreen-ui/leafygreen-provider@1.1.0

## 1.0.1

### Patch Changes

- 62455d4: Switches devDependencies to dependencies in package.json

## 1.0.0

### Major Changes

- 5f08f87: Initial release of TextInput component

### Patch Changes

- Updated dependencies [704e25c]
  - @leafygreen-ui/lib@4.3.1
